#!/usr/bin/env perl6

use File::HomeDir;

sub MAIN ( $file, Int :$offset = 1, Bool :$local ) {
    die "No such file $file" unless $file.IO.e;

    my $date = Date.today + $offset;

    my $ok = prompt "Creating POTD for $date, ok? ";
    exit if $ok ~~ m:i/^n/;

    my $home       = File::HomeDir.new.my_home.IO;
    my $blio       = $home.child( 'privat/domm.plix.at' );
    my $target_img = $blio.child( 'src/potd/' ~ $date ~ '.jpg' );
    my $target_txt = $blio.child( 'src/potd/' ~ $date ~ '.txt' );
    my $archive    = $home.child( 'media/fotos/2015/potd/' ~ $date ~ '.jpg' );

    my $template = template( $date );
    spurt $target_txt, $template, :createonly;
    shell "vim $target_txt";

    shell "potd_handle_image.pl $file $target_img $archive";

    publish( $target_img, $target_txt, $date );

    build_local( $blio ) if $local;
}

sub template ( Date $date ) {
    my $publish_datetime = $date ~ 'T10:00:00';
    return qq:to/EOBLIO/;
    title: 
    tweet: 
    date: $publish_datetime
    converter: textile
    template: potd.tt
    
    
    EOBLIO
}

sub publish ( $target_img, $target_txt, $basename ) {
   chdir $target_img.dirname;
   my @commands =
       "git add $target_img $target_txt",
       "git commit -m 'potd $basename'",
       "git push";
   for @commands -> $command {
      shell $command;
   }
}

sub build_local ( $blio ) {
   chdir $blio;
   say   "starting to build local website";
   shell './build_t430 --nosched > /dev/null';
   say   "done building local website";
}

